<?php
namespace AustraliaPost\Extensions\Business\API\Wrapper;

class Create_Pickup_Request {

	private $pickup_date;
	private $product_id;
	private $shipment_ids = [];
	/** @var Address */
	private $from;
	private $pickups;

	/**
	 * @return mixed
	 */
	public function getPickupDate() {
		return $this->pickup_date;
	}

	/**
	 * @param mixed $pickup_date
	 *
	 * @return Create_Pickup_Request
	 */
	public function setPickupDate( $pickup_date ) {
		$this->pickup_date = $pickup_date;

		return $this;
	}

	/**
	 * @return mixed
	 */
	public function getProductId() {
		return $this->product_id;
	}

	/**
	 * @param mixed $product_id
	 *
	 * @return Create_Pickup_Request
	 */
	public function setProductId( $product_id ) {
		$this->product_id = $product_id;

		return $this;
	}

	/**
	 * @return array
	 */
	public function getShipmentIds(): array {
		return $this->shipment_ids;
	}

	/**
	 * @param string $shipment_id
	 *
	 * @return Create_Pickup_Request
	 */
	public function addShipment( $shipment_id ): Create_Pickup_Request {
		$this->shipment_ids[] = $shipment_id;

		return $this;
	}

	/**
	 * @return Address
	 */
	public function getFrom(): Address {
		return $this->from;
	}

	/**
	 * @param Address $from
	 *
	 * @return Create_Pickup_Request
	 */
	public function setFrom( Address $from ): Create_Pickup_Request {
		$this->from = $from;

		return $this;
	}

	/**
	 * @return mixed
	 */
	public function getPickups() {
		return $this->pickups;
	}

	/**
	 * @param mixed $pickups
	 *
	 * @return Create_Pickup_Request
	 */
	public function setPickups( $pickups ) {
		$this->pickups = $pickups;

		return $this;
	}

	/**
	 * @return array
	 */
	public function getPayload()
	{
		$data = [];
		$payLoad = [];
		$data['pickup_date'] = date('Y-m-d', strtotime($this->getPickupDate()));
		$data['product_id'] = $this->getProductId();
		$data['shipment_ids'] = $this->getShipmentIds();
		$data['from'] = $this->getFrom()->getPayLoad();
		$payLoad['pickups'][] = $data;
		return $payLoad;
	}

}
